const lo = require('lodash')
// return b_ck for using proto
// be_w method use the proto object default argument

const _ = this
module.exports = lo.once(parentModuleSrc => {
  // _dash
  _.__proto__ = lo
  _.__proto__.__proto__ = require('underscore-contrib')
  _.lodash_config()
  // nodejs
  _.each(_.nodejs_module, v => _.require(v))
  // proto.assign(proto.__proto__, at_module.call(proto))
  _.extend(_, {
    hl: require('highland'),
    fp: require('lodash/fp'),
    s: require('underscore.string'),
  })
  _.S = fn => {
    const string = require('string')
    string.extendPrototype()
    fn()
    string.restorePrototype()
  }
  _.fail = state => {
    throw new Error(state)
  }

  _.warn = state => {
    console.log(`WARNING: ${state}`)
  }

  _.note = state => {
    console.log(`NOTE: ${state}`)
  }
  const parentDir = _.path.dirname(parentModuleSrc)
  _.parentCwd = _.findUp('package.json', parentDir)
  const user_dependency = _.get_dependencies(`${_.parentCwd}/package.json`)
  const at_dependency = _.get_dependencies(`../package.json`)
  const dependency = _.union(user_dependency, at_dependency)
  // should transform object so must not set should in this, because this is object
  _.each(_.pull(dependency, 'should'), v => _.require(v))
  _.user_config(`${_.parentCwd}/at-config.js`)
  return _
})

_.nodejs_module = [
  'assert', 'util', 'zlib', 'v8', 'vm', 'crypto',
  'child_process', 'cluster', 'events',
  'fs', 'path', 'stream', 'readline', 'string_decoder',
  'os', 'process',
  'http', 'https', 'net', 'url', 'querystring', 'dgram',
]


_.get_dependencies = pkgSrc => {
  const pkg = require(pkgSrc)
  return _.concat(
    _.keys(_.defaultTo(pkg.dependencies), {}),
    _.keys(_.defaultTo(pkg.devDependencies), {})
  )
}
_.inherit = (fromCtx, toCtx = _) => {
  const tmpProto = toCtx.__proto__
  toCtx.__proto__ = fromCtx
  toCtx.__proto__.__proto__ = tmpProto
}
_.require = (name, afterName = name, ctx = _) => {
  if (_.isObject(afterName)) [afterName, ctx] = [name, afterName]
  Object.defineProperty(ctx, afterName, {
    get: () => {
      let module = _.attempt(require, name)
      // so require lazily, require needs path relative with parentCwd
      if (module.code === 'MODULE_NOT_FOUND') module = _.attempt(require, `${_.parentCwd}/node_modules/${name}`)
      return module
    },
  })
}

_.lodash_config = () => {
// set for using regex in _dash-iteratee (cf : _dash menual)
  _.iteratee = _.wrap(_.iteratee, (iteratee, func) => {
    return _.isRegExp(func) ? str => func.test(str) : iteratee(func)
  })
  _.c = _.curry
  _.C = _.curryRight
  _.p = _.partial
  _.P = _.partialRight
  _.k = _.constant
}

_.findUp = (filename, baseDir) => {
  // const parentSrc = module.parent.filename.replace(/\/[^/]+.js$/, '')
  const allFilesInTargetDir = this.fs.readdirSync(baseDir)
  const hasTheFile = _.includes(allFilesInTargetDir, filename)
  if (hasTheFile) return baseDir
  return this.findUp(filename, this.path.resolve(baseDir, '..'))
  // return '/Volumes/mac/3/jats/project/node_modules/at-_dash'
}

_.user_config = cfgSrc => {
  const cfgFun = this.attempt(require, cfgSrc)
  const ret = this.attempt(cfgFun.bind(this)) || {}
  console.log(this.wow)
  switch (cfgFun.code || ret.message) {
    case 'MODULE_NOT_FOUND':
      return _.warn(`at-lodash need to have ${_.parentCwd}/at-config.js`)
    case 'func.call is not a function':
      console.warn('at-config.js module must be a function')
    default:
      console.log(cfgFun.code || ret.message)
  }
  // if (cfgFun.code === 'MODULE_NOT_FOUND') console.warn(`at-_dash: need to have ${_.parentCwd}/at-config.js`)
}
